package il.ac.tau.cs.smlab.model2lejos.library.wrappers.colordistinguisher;

import lejos.nxt.ColorSensor.Color;

/**
 * Implementation of component ColorDistinguisher used to get the color,
 * its name or the red, green and blue components 
 */
public class ColorDistinguisherImpl extends ColorDistinguisher {

	/**
	 * Constructor
	 */
	public ColorDistinguisherImpl() {
	  super();
	}

	
	/**
	 * Evaluate the color set in the inport color of the ColorDistinguisher.
	 * Results are set in the various outports of the ColorDistinguisher component.
	 */
  @Override
  public void compute() {
    if(this.color!= null && this.color.getCurrentValue()!=null)
    {
    	Color rgb = this.color.getCurrentValue();
    	
    	this.colorValue.setNextValue(rgb);
    	this.colorNumber.setNextValue(rgb.getColor());
    	this.rgbValues.setNextValue(rgb.getRed()   + ";" 
    							  + rgb.getGreen() + ";" 
    							  + rgb.getBlue());
    	this.redValue.setNextValue(rgb.getRed());
    	this.greenValue.setNextValue(rgb.getGreen());
    	this.blueValue.setNextValue(rgb.getBlue());
    	
    	switch(rgb.getColor())
    	{
    	case Color.BLACK: 
    		this.colorName.setNextValue("BLACK");
    		break;
    	case Color.BLUE: 
    		this.colorName.setNextValue("BLUE");
    		break;
    	case Color.CYAN: 
    		this.colorName.setNextValue("CYAN");
    		break;
    	case Color.DARK_GRAY: 
    		this.colorName.setNextValue("DARK_GRAY");
    		break;
    	case Color.GRAY: 
    		this.colorName.setNextValue("GRAY");
    		break;
    	case Color.GREEN: 
    		this.colorName.setNextValue("GREEN");
    		break;
    	case Color.LIGHT_GRAY: 
    		this.colorName.setNextValue("LIGHT_GRAY");
    		break;
    	case Color.MAGENTA: 
    		this.colorName.setNextValue("MAGENTA");
    		break;
    	case Color.ORANGE: 
    		this.colorName.setNextValue("ORANGE");
    		break;
    	case Color.PINK: 
    		this.colorName.setNextValue("PINK");
    		break;
    	case Color.RED: 
    		this.colorName.setNextValue("RED");
    		break;
    	case Color.WHITE: 
    		this.colorName.setNextValue("WHITE");
    		break;
    	case Color.YELLOW: 
    		this.colorName.setNextValue("YELLOW");
    		break;
    	case Color.NONE: 
    		this.colorName.setNextValue("NONE");
    		break;
    	}
    	
    }
  }

}
