package il.ac.tau.cs.smlab.model2lejos.library.wrappers.soundonbrick;

//import java.sql.Time;

import lejos.nxt.Sound;

/**
 * Implementation of SoundOnBrick, used to play single beep tones or some music chords
 */
public class SoundOnBrickImpl extends SoundOnBrick {

	static int  c = 261;
	static int  d = 294;
	static int  e = 329;
	static int  f = 349;
	static int  g = 391;
	static int  gS = 415;
	static int  a = 440;
	static int  aS = 455;
	static int  b = 466;
	static int  cH = 523;
	static int  cSH = 554;
	static int  dH = 587;
	static int  dSH = 622;
	static int  eH = 659;
	static int  fH = 698;
	static int  fSH = 740;
	static int  gH = 784;
	static int  gSH = 830;
	static int  aH = 880;
	
	/**
	 * Constructor
	 */
	public SoundOnBrickImpl(){
		super();
	}
	
	/**
	 * SetUp the Volume
	 */
	@Override
	public void init()
	{
		Sound.setVolume(50);
	}
	
	/**
	 * Play a single Beep if inport bPlaySingleBeep is set or some coords of the imperial march
	 * if inport bPlayImperialMarch is set
	 * 
	 * @see SoundOnBrick#bPlaySingleBeep
	 * @see SoundOnBrick#bPlayImperialMarch
	 */
	@Override
	public void compute() {
		
		if(this.bPlaySingleBeep != null && this.bPlaySingleBeep.getCurrentValue() != null)
		{
			  if(this.bPlaySingleBeep.getCurrentValue())
				  Sound.beep();
		}
		if(this.bPlayImperialMarch != null && this.bPlayImperialMarch.getCurrentValue() != null &&
			this.bPlayImperialMarch.getCurrentValue())
		{
			// first two parts of the Imperial March, Star Wars
			Sound.playNote(Sound.PIANO,a, 500);
      	    Sound.playNote(Sound.PIANO,a, 500);
      	    Sound.playNote(Sound.PIANO,a, 500);
      	    Sound.playNote(Sound.PIANO,f, 350);
      	    Sound.playNote(Sound.PIANO,cH, 150);  
      	    Sound.playNote(Sound.PIANO,a, 500);
      	    Sound.playNote(Sound.PIANO,f, 350);
      	    Sound.playNote(Sound.PIANO,cH, 150);
      	    Sound.playNote(Sound.PIANO,a, 650);
      	 
      	    Sound.pause(150);
      	    
      	    Sound.playNote(Sound.PIANO,eH, 500);
      	    Sound.playNote(Sound.PIANO,eH, 500);
      	    Sound.playNote(Sound.PIANO,eH, 500);   
      	    Sound.playNote(Sound.PIANO,fH, 350);
      	    Sound.playNote(Sound.PIANO,cH, 150);
      	    Sound.playNote(Sound.PIANO,gS, 500);
      	    Sound.playNote(Sound.PIANO,f, 350);
      	    Sound.playNote(Sound.PIANO,cH, 150);
      	    Sound.playNote(Sound.PIANO,a, 650);
		}
	}

}
